// #include "/home/tikhon/Documents/programs/testlib/testlib.h"
#include "testlib.h"

#include <bits/stdc++.h>
using namespace std;

#define pii pair<int, int>
#define all(a) (a).begin(), (a).end()
map<string, string> params;

vector<string> mods = {"wrand", "equal_sum"};

int get(string name, int def) {
    if (params.count(name)) def = stoi(params[name]);
    return def;
}

string get(string name, string def) {
    if (params.count(name)) return params[name];
    return def;
}

vector<int> get_arr(string name) {
    auto str = params[name] + ","; 
    vector<int> arr;
    int cur = 0;
    for (char h : str) {
        if (h == ',') {
            arr.push_back(cur);
            cur = 0;
        } else {
            cur = cur * 10 + (h - '0');
        }
    }
    return arr;
}

void cut_w(vector<int>& v, int w) {
    int sum_cut = 0;
    for (int& i : v) {
        sum_cut += max(0, i - w);
        i = min(i, w);
    }
    if (sum_cut > 0) {
        cerr << "WARNING: cut " << sum_cut << " of w in total\n";
    }
}

void cut_w2(vector<int>& v) {
    int sum_cut = 0;
    for (int i = 0; i + 1 < v.size(); ++i) {
        if (2 * v[i] < v[i + 1]) {
            sum_cut += v[i + 1];
            v[i + 1] = 2 * v[i];
            sum_cut -= v[i + 1];
        }
    }
    if (sum_cut > 0) {
        cerr << "WARNING: cut (2*w[i] >= w[i+1]) " << sum_cut << " of w in total\n";
    }
}

vector<int> gen(int& n, int W, int w, string mode) {
    vector<int> v;

    if (mode == "wrand") {
        v.resize(n);
        // ignores w
        int t = get("t", 0);

        vector<int> pw(n - 1);
        for (int i = 0; i < n - 1; ++i) pw[i] = rnd.wnext(W - n + 1, t);
        pw.push_back(0);
        pw.push_back(W - n);
        sort(all(pw));

        for (int i = 0; i < n; ++i) {
            v[i] = pw[i + 1] - pw[i] + 1;
        }
    }

    if (mode == "equal_sum") {
        auto core = get_arr("core");
        multiset<pii> sum_who;
        for (int i : core) {
            sum_who.insert({0, i});
        }
        int sum = 0;
        while (v.size() < n) {
            auto it = sum_who.begin();
            if (sum + it->second > W) break;
            sum += it->second;
            v.push_back(it->second);
            sum_who.insert({it->first + it->second, it->second});
            sum_who.erase(it);
        }

        if (v.size() < n) {
            cerr << "WARNING: n is lowered from " << n << " to " << v.size() << '\n';
            n = v.size(); 
        }
    }

    int sum = 0;
    for (int i : v) sum += i;

    int noize = get("noize", 0);
    if (noize != 0) {
        vector<int> vnoize(n);
        int sum_noize = 0;
        for (int i = 0; i < n; ++i) {
            vnoize[i] = rnd.next(-min(noize, v[i] - 1), min(noize, v[i] - 1));
            sum_noize += vnoize[i];
        }

        if (sum + sum_noize > W) {
            for (int i = 0; i < n; ++i) {
                vnoize[i] *= -1;
            }
        }

        for (int i = 0; i < n; ++i) {
            v[i] += vnoize[i];
        }    
    }

    sum = 0;
    for (int i : v) sum += i;

    if (W - sum > W / 5) {
        cerr << "WARNING: sum w is only " << sum << " instead of " << W << '\n';
    }
    
    assert(sum <= W);

    sort(all(v));

    cut_w(v, w);

    if (params.count("cut_w2")) {
        cut_w2(v);
    }

    return v;
}

int main(int argc, char* argv[]){
    registerGen(argc, argv, 1);

    for (int i = 1; i < argc; i++) {
        string s = string(argv[i]);
        if (s.find("=") != string::npos) {
            auto pos = s.find("=");
            params[s.substr(0, pos)] = s.substr(pos + 1);
        }
    }


    int n = stoi(params["n"]);

    int W = get("W", 20000);
    int w = get("w", 20000);

    string mode = get("mode", "any");
    if (mode == "any") mode = rnd.any(mods);

    auto v = gen(n, W, w, mode);

    cout << n << '\n';
    for (int i = 0; i < n; ++i) {
        cout << v[i] << (i + 1 == n ? "" : " ");
    }
    cout << '\n';

    return 0;
}
