#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("unswitch-loops")
#pragma GCC optimize("fast-math")
#pragma GCC optimize("rename-registers")

using namespace std;

using pi = pair<int, int>;
using vi = vector<int>;
using vpi = vector<pi>;

const int maxN = 2e3;

int n, w[maxN], ans;
vi pos[maxN][maxN], dp[maxN][maxN];

void solve() {
#ifdef LOCAL
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            pos[i][j].clear();
            dp[i][j].clear();
        }
    }
    ans = 0;
#endif
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        ans += w[i];
    }
    
    int pt = clock();
    
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            if (j + 1 != n) {
                pos[i][j].reserve(w[j + 1] * 2 + 1);
            }
        }
    }
    
    pos[0][n - 1].push_back(0);
    for (int len = n; len > 1; len--) {
        for (int i = 0; i + len <= n; i++) {
            int j = i + len - 1;
            sort(pos[i][j].begin(), pos[i][j].end());
            pos[i][j].resize(unique(pos[i][j].begin(), pos[i][j].end()) - pos[i][j].begin());
            for (int h : pos[i][j]) {
                if (h >= 0) {
                    pos[i + 1][j].push_back(h - w[i]);
                    pos[i][j - 1].push_back(h - w[j]);
                } else {
                    pos[i + 1][j].push_back(h + w[i]);
                    pos[i][j - 1].push_back(h + w[j]);
                }
            }
        }
    }
    
    int pt1 = clock();
    cerr << "pt1 : " << 1.0 * (pt1 - pt) / CLOCKS_PER_SEC << '\n';
    
    for (int i = 0; i < n; i++) {
        sort(pos[i][i].begin(), pos[i][i].end());
        pos[i][i].resize(unique(pos[i][i].begin(), pos[i][i].end()) - pos[i][i].begin());
        for (int j : pos[i][i]) {
            if (j >= 0) {
                dp[i][i].push_back(w[i]);
            } else {
                dp[i][i].push_back(-w[i]);
            }
        }
    }
    for (int len = 2; len <= n; len++) {
        for (int i = 0; i + len <= n; i++) {
            int j = i + len - 1;
            int l = 0, r = 0;
            for (int h : pos[i][j]) {
                if (h >= 0) {
                    while (pos[i + 1][j][l] > h - w[i]) {
                        l--;
                    }
                    while (pos[i][j - 1][r] > h - w[j]) {
                        r--;
                    }
                    while (pos[i + 1][j][l] < h - w[i]) {
                        l++;
                    }
                    while (pos[i][j - 1][r] < h - w[j]) {
                        r++;
                    }
                    dp[i][j].push_back(max(dp[i + 1][j][l] + w[i], dp[i][j - 1][r] + w[j]));
                } else {
                    while (pos[i + 1][j][l] < h + w[i]) {
                        l++;
                    }
                    while (pos[i][j - 1][r] < h + w[j]) {
                        r++;
                    }
                    dp[i][j].push_back(min(dp[i + 1][j][l] - w[i], dp[i][j - 1][r] - w[j]));
                }
            }
        }
    }
    
    int pt2 = clock();
    cerr << "pt2 : " << 1.0 * (pt2 - pt1) / CLOCKS_PER_SEC << '\n';
    
    cout << (ans + dp[0][n - 1][0]) / 2 << " " << (ans - dp[0][n - 1][0]) / 2 << "\n";
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int test = 1;
#ifdef LOCAL
    cin >> test;
#endif
    while (test--) {
        solve();
    }
    return 0;
}
